package common;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.math.BigDecimal;
import org.jstk.example.bank.Exceptions;

public interface RemoteBank extends Remote {
	public RemoteAccount openAccount(BigDecimal initialDeposit) throws RemoteException;
	public void closeAccount(String acctNo) throws Exceptions.AccountNotFound,
			Exceptions.AccountClosed, RemoteException;
	public RemoteAccount getAccount(String acctNo) throws Exceptions.AccountNotFound, RemoteException;
	public RemoteIterator accounts() throws RemoteException;
}
