package coreservlets;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

/** Prosty serwlet wywietlajcy komunikaty o bdach uytkownikom,
 *  ktrzy prbuj wywoa domylny URL serwletu 
 *  (tzn. http://komputer/prefiksAplikacjiWWW/servlet/nazwaSerwletu)
 *  w aplikacjach internetowych, w ktrych taka moliwo
 *  zostaa wyczona.
 *  <P>
 *  Taken from Core Servlets and JavaServer Pages Volume II
 *  from Prentice Hall and Sun Microsystems Press,
 *  http://volume2.coreservlets.com/.
 *  (C) 2007 Marty Hall, Larry Brown, and Yaakov Chaikin;
 *  may be freely used or adapted.
 */

public class NoInvokerServlet extends HttpServlet {
  public void doGet(HttpServletRequest request,
                    HttpServletResponse response)
      throws ServletException, IOException {
    response.setContentType("text/html");
    response.setCharacterEncoding("UTF-8");
    PrintWriter out = response.getWriter();
    String docType =
      "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 " +
      "Transitional//EN\">\n";
    String title = "Wywoywacz serwletu zosta wyczony.";
    out.println
      (docType +
       "<HTML>\n" +
       "<HEAD><TITLE>" + title + "</TITLE></HEAD>\n" +
       "<BODY BGCOLOR=\"#FDF5E6\">\n" +
       "<H2>" + title + "</H2>\n" +
       "Przepraszamy, dostp do serwletw przez adresy URL rozpoczynajce si od \n" +
       "http://komputer/prefiksAplikacjiWWW/servlet/\n" +
       "zosta wyczony.\n" +
       "</BODY></HTML>");
  }

  public void doPost(HttpServletRequest request,
                    HttpServletResponse response)
      throws ServletException, IOException {
    doGet(request, response);
  }
}
