package coreservlets;

import javax.servlet.*;
import java.util.*;

/** Prosty proces nasuchujcy, ktry przesya do standardowego wyjcia  *  odpowiedni komunikat za kadym razem, gdy dochodzi do utworzenia 
 *  lub zniszczenia obiektu ServletContext.
 *  <P>
 *  Taken from Core Servlets and JavaServer Pages Volume II
 *  from Prentice Hall and Sun Microsystems Press,
 *  http://volume2.coreservlets.com/.
 *  (C) 2007 Marty Hall, Larry Brown, and Yaakov Chaikin;
 *  may be freely used or adapted.
 */

public class ContextReporter implements ServletContextListener {
  public void contextInitialized(ServletContextEvent event) {
    System.out.println("Kontekst utworzony w dniu " +
                       new Date() + ".");
  }

  public void contextDestroyed(ServletContextEvent event) {
    System.out.println("Kontekst zniszczony w dniu " +
                       new Date() + ".");
  }
}
